#include <list>
#include <string>
#include <assert.h>
#include <windows.h>
#include <process.h>
using namespace std;

typedef list<string> LISTSTR;

class Console
{
private:
	int x1, x2, y1, y2, maxLines, maxChars;
	int locate_x, locate_y;
	bool showConsole;
	LISTSTR strBuffer;
	void NewLine();
	void _Print(string newString);
	FILE *logFile;
	HANDLE hBufferMutex;
	DWORD dwWaitResult; 
public:
	Console();
	Console(char* _logFileName, int x1, int y1, int x2, int y2);
	~Console();
	void SetSize(int x1, int y1, int x2, int y2);
	void Printf(LPCSTR lpszFormat, ...);
	void _Printf(string newString);
	void Printfn(LPCSTR lpszFormat, ...);
	void _Printfn(string newString);
	void Show() {showConsole = true;};
	void Hide() {showConsole = false;};
	void Toggle() {showConsole = !showConsole;};
	void Draw();
};