#include <windows.h>
#include <stdio.h>
#include <assert.h>

class LogFile
{
private:
	FILE *accLogFile;
	bool writeEn, doneReadingLog;
public:
	LogFile();
	~LogFile() 
	{
		if (accLogFile != NULL)
		{
			fprintf(accLogFile, "\n");
			fclose(accLogFile);
		}
	};

	bool OpenForWriting(char* fileName);
	bool OpenForReading(char* fileName);
	void Close();

	bool Printf(LPCSTR lpszFormat, ...);
	int ReadLine(BYTE buffer[]);
	bool IsLogFinished() {return doneReadingLog;};
};
